program che_evo_main
use dfport
use nrtype
use lifetime
use mod_imf
use checod_glob
use modname
use msflib ! solo per fortran MSPWS

implicit none

real(sp)::ela_tim

ela_tim=secnds(0.0)


call getarg(1_2,name)

if (arg_empty(name)) then
! invalid program use
	write(*,10)
else
! parsing if command line
    call command_line_interpret

    call getarg(0_2,name_dir)

	call clean_name_dir

    call che_evo                                            
    ela_tim=secnds(0.0)-ela_tim
    write(*,*) "elapsed time (sec) = ",ela_tim

endif

10   format(' I need at least one argument to run!',/, &
     ' Usage: che_evo {model_name} [par=value]...',/,' Cheers!')


contains
!*********
    subroutine command_line_interpret
    integer*2::i
    character*80::scra
    integer::j

    ! storage of parameters passed on command line, if any
    nopt=iargc()-1
    if (nopt>0) then
         allocate(opt(nopt),STAT=i)
         IF (I.NE. 0) THEN
             PRINT *, "ALLOCATION ERROR IN SOUCOU MAIN"
             STOP
         ENDIF
         do i=1,nopt
      		 call getarg(i+1,scra)
             j=INDEX(scra,'=')-1
	         if (j<=0) then
                  print *,'Invalid argument in command line (missing =)'
                  stop
              else
                   opt(i)(1:10) = scra(1:j)
                   opt(i)(11:20) = scra(j+2:)
              endif
         enddo         

	endif

    end subroutine command_line_interpret

!***********
	subroutine clean_name_dir
!     serve per ricavare il nome della directory dove risiede l'eseguibile
!     e quindi le librerie di ssp e di Q dalla riga di comando, 
!     preventivamente memorizzata in name_dir.
		use modname
		implicit none
		integer(i4b)::last

		
		last=scan(name_dir,'/\',back=.true.)! / per Unix--like, \ per Win-like

		if (last==0) then
			name_dir=' '
		else
			name_dir=name_dir(1:last)
		endif

	end subroutine clean_name_dir


end

!*********************************************************
module PARAMETRI
! module to process input of main parameters

use modname

use lifetime
use mod_imf
use checod_glob
use schmidt
use infall


CHARACTER (len=10), private, save :: KEY
character (len=84), private, save ::nomfil
integer,save, private:: nfound
real,private:: val

type partype
   character*10::name
   logical::found
end type partype

integer, parameter:: npar=12

type (partype), dimension(npar)::par

contains

!**********
    LOGICAL FUNCTION R2L(VAL)
!   RITORNA FALSE SE L'INTERO PIU' PROSSIMO A VAL E' 0, TRUE ALTRIMENTI
    real val 
    IF (NINT(VAL).EQ.0) THEN
         R2L=.FALSE.
    ELSE
         R2L=.TRUE.
    ENDIF
    END function R2L
      
!**********
    CHARACTER*10 FUNCTION R2C(VAL)
!scrive come stringa un real
    real val 
    integer valint
	character*10 tmp
    valint=val
    if (valint>99) then
          write(tmp,'(i3)') valint 
	else if (valint>9) then
          write(tmp,'(i2)') valint 
	else
          write(tmp,'(i1)') valint 
    endif
	R2C=tmp
    END function R2C

!**********
    subroutine setpar

    IF (KEY==par(1)%name) THEN
          t_fin=VAL
          par(1)%found=.TRUE.
    ELSE IF (KEY==par(2)%name) THEN
          k_sch=VAL
          par(2)%found=.TRUE.
    ELSE IF (KEY==par(3)%name) THEN
          t_win=VAL
          par(3)%found=.TRUE.
    ELSE IF (KEY==par(4)%name) THEN
          i_sfr_m=VAL
          par(4)%found=.TRUE.
    ELSE IF (KEY==par(5)%name) THEN
          i_sfr_t=VAL
          par(5)%found=.TRUE.
    ELSE IF (KEY==par(6)%name) THEN
          nu_sch=VAL
          par(6)%found=.TRUE.
    ELSE IF (KEY==par(7)%name) THEN
          tau_inf=VAL
          par(7)%found=.TRUE.
    ELSE IF (KEY==par(8)%name) THEN
          m_inf=VAL
          par(8)%found=.TRUE.
    ELSE IF (KEY==par(9)%name) THEN
          t_inf=VAL
          par(9)%found=.TRUE.
    ELSE IF (KEY==par(10)%name) THEN
          m_up=VAL
          par(10)%found=.TRUE.
    ELSE IF (KEY==par(11)%name) THEN
          int_flag=R2L(VAL)
          par(11)%found=.TRUE.
    ELSE IF (KEY==par(12)%name) THEN
          f_win=VAL
          par(12)%found=.TRUE.
    else
          call nrerror('Unknown key in file '//nomfil//': '//key)
    ENDIF

    end subroutine setpar


!**********
    SUBROUTINE inp_par
    implicit none
    !Legge i parametri nella sezione MAIN del file nome.che
    !Le regole per costruire la sezione .che sono:
    !1) le righe che iniziano con il carattere %, #, ! o uno spazio
    !sono ignorate, ovvero sono di commento.
    !2) in tutti gli altri casi le colonne 1-10 contengono
    !una stringa chiave, giustificata a sx, quelle 11-20 un numero REALE
    !e le successive sono ignorate quindi si possono usare per scrivere
    !commenti. La chiave serve al programma per riconoscere a quale
    !parametro il numero successivo si riferisce, e di solito corrisponde
    !al nome usato nel codice per detto parametro.
    !3) e' buona regola concludere il file con una riga di commento,
    !per evitare idiosincrasie dipendenti dal compilatore usato nella
    !istruzione READ.
           

    CHARACTER*1 PRICAR 
    CHARACTER*10 VALSTR
    logical::ancora=.true.
    integer(i4b):: i,read_stat
	integer, parameter:: keyind=1
    character(80)::comment_line

    par%name=(/ &
    't_fin     ' & !1
   ,'k_sch     ' & !2
   ,'t_win     ' & !3 
   ,'i_sfr_m   ' & !4
   ,'i_sfr_t   ' & !5
   ,'nu_sch    ' & !6
   ,'tau_inf   ' & !7
   ,'m_inf     ' & !8
   ,'t_inf     ' & !9
   ,'m_up      ' & !10
   ,'int_flag  ' & !11
   ,'f_win     ' & !12
    /) 


    par%found=.false.
       
	nomfil=trim(name)//'.che'
    OPEN(20,FILE=nomfil)
    if (.not.search_key_in_file(20,seckeys(keyind))) then
        write(*,*) 'Key ',seckeys(keyind),'not found in file ',trim(name)//'.che'
        stop
    endif

    nfound=0
    DO while (ancora)
         READ(20,'(A1)',END=999,ERR=999)PRICAR
 !       Ignoro le righe che cominciano con uno %,# o spazio.
         if (scan(pricar,'%#! ')==0) then
            BACKSPACE(20)
            ! passaggio intermedio per valstr in modo da poter fare un lettura
	        ! non formattata e quindi entrare reali anche senza punto decimale
            READ (20,19) KEY,VALSTR

            if (any(KEY==seckeys)) then ! fine sezione
                 ancora=.false.
            else
                 read (VALSTR,*) val 
                 call setpar
            endif
         ENDIF
    ENDDO
999 CONTINUE


!    open(21,file=trim(name)//'.out',status='OLD',position='APPEND')

    ! eventuale resettaggio di parametri da linea di comando
    DO i=1,nopt
     ! passaggio intermedio per valstr in modo da poter fare un lettura
     ! non formattata e quindi entrare reali anche senza punto decimale
         READ (opt(i),19) KEY,VALSTR
         read (VALSTR,*) val 
         write(*,*) 'Forcing ', key(1:index(key,' ')), 'to ', val
         call setpar
    ENDDO

!    close(21)


 19   FORMAT(2A10)

    IF (any(.not.par%found)) THEN
        WRITE (*,*) 'FATAL ERROR - missing parameter(s) in file ', &
        nomfil(1:INDEX(nomfil,' ')-1),':'
        do i=1,npar
              if (.not.par(i)%found) then
                 write (*,*) par(i)%name
              endif
	     enddo
         stop
     ENDIF


	if (i_sfr_t/=0) then
		rewind(20)
		if (.not.search_key_in_file(20,seckeys(3))) then
                 write(*,*) "Key ANALY not found in file ",nomfil
	             stop
		endif

		read(20,'(a80)') comment_line

		read(20,*) t1_sfr_t,t2_sfr_t,fra_sfr_t,tau_sfr_t
	endif	
		
	
	
	CLOSE(20)

    t_inf=min(t_inf,t_win)
    a_inf=m_inf/tau_inf/(1-exp(-t_inf/tau_inf))


    END subroutine inp_par


END MODULE parametri



!**************************************
subroutine che_evo

use nrtype
use nr90_gian, only:qromb_eps
use nr, only:odeint,rkqs
use ode_path
use modname
use parametri
use lifetime
use mod_imf
use checod_glob
use schmidt
use infall


implicit none

real(sp)::dt,res,ssp_mass
integer(i4b)::i

! variables to cope with wind: we set m_gas=0 at t_win and the gas lost
! has to be subtracted also to the total infall mass computed in out_cyc
real(sp),save::mg_t_win=0, mg_soon_after_win=0 ! 
logical,save::soon_after_win=.false. 



                                                         
call inp_par


res=imf(3.0,name(1:INDEX(name,' ')-1)//'.che',ssp_mass) ! to initialize t_lif_???

dt=t_lif_min*0.99
n_tim=t_fin/dt+1
if (mod(t_fin,dt)/=0) then
    n_tim=n_tim+1
endif

call glob_init


t_arr(1)=1.0e-20 ! 
mg_arr(1,1)=0 !8e10
mg_arr(1,2)=0 !2e10
mg_arr(1,3)=0.0

i_now=1

open(17,file=name(1:INDEX(name,' ')-1)//'.sf')

write(17,'(a1)',advance="no") "#"
write(17,18) m_up,snI_su_snII
18 format ( &
"1:i_out, 2:t, 3:sfr, 4:zeta, 5:mgas, 6:mstar, 7:mtot, 8:snr (m_up=" &
, f6.2," SNI/SNII=",f7.3,")")
write(17,'(a1,g15.5)') "#", ssp_mass 
write (17,"('#',2x,i1,20(5x,i2,6x))") 1,(i,i=2,8)


call update_mg_zet_sfr(1)

!call out_cyc(1)


do i_now=1,n_tim-1

!   alive stars
    t_fee_bac=t_arr(i_now)
    ms_arr(i_now) = qromb_eps(fun_star_alive,t_arr(1),t_fee_bac,1e-5)
 
!   SN rate
    tmax=t_fee_bac - t_lif_min
    tmax=max(tmax,t_arr(1))
    tmin=t_fee_bac-life(m_up,zet_arr(i_now),0) 
    ! since lifetime is not a strong function of z, we can evaluate at present z
    tmin=max(tmin,t_arr(1))
    snr_arr(i_now) = -qromb_eps(fun_snr,tmin,tmax,1e-4)*(1+snI_su_snII)

    call out_cyc(i_now)

!   integration over next timestep    
    t_arr(i_now+1)=min((i_now)*dt,t_fin) ! to avoid overshoot
    ! in last cycle

    mg_now_arr(:)=mg_arr(i_now,1:n_ele) 
    call odeint(mg_now_arr,t_arr(i_now), &
    t_arr(i_now+1),1e-3,dt,1e-2*dt,derivs,rkqs)
 
	if ((t_arr(i_now+1)>t_win).and.(.not.soon_after_win)) then
		soon_after_win=.true.
		mg_arr(i_now+1,1:n_ele)=0
	else
		mg_arr(i_now+1,1:n_ele)=mg_now_arr(:)
	endif

    call update_mg_zet_sfr(i_now+1)

enddo

! final alive stars
i_now=n_tim ! not strictly required
t_fee_bac=t_arr(i_now)
ms_arr(i_now) = qromb_eps(fun_star_alive,t_arr(1),t_fee_bac,1e-5)

! final SN rate
tmax=t_fee_bac - t_lif_min
tmax=max(tmax,t_arr(1))
tmin=t_fee_bac-life(m_up,zet_arr(i_now),0) 
! since lifetime is not a strong function of z, we can evaluate at present z
tmin=max(tmin,t_arr(1))
snr_arr(i_now) = -qromb_eps(fun_snr,tmin,tmax,1e-4)*(1+snI_su_snII)



call out_cyc(i_now)


close(17)
call glob_finish


contains 



!***********
    subroutine out_cyc(i_out)
    integer(i4b),intent(in)::i_out
    logical::printout
    integer,save::i_las=1
    real,parameter::eps=0.01 ! minumin % variation for printout
    

    if ((i_out==1).or.(i_out==n_tim)) then
!   write always first or last computation
        printout=.true.
    else
        if (sfr_arr(i_out)==0 .and. sfr_arr(i_out-1)/=0) then
        !   first computation after sfr stopped by wind
! ??? ricordiamoci di far stampare in tal caso anche il 
! penultimo
            printout=.true.
            call print_step(i_out-1,i_las)
			mg_t_win=mg_arr(i_out-1,0) ! mass lost due to wind    
			mg_soon_after_win=mg_arr(i_out,0) ! mass lost due to wind    
        else
            printout= &
            abs( (zet_arr(i_out)-zet_arr(i_las))/zet_arr(i_out) ).gt.eps 
            if (sfr_arr(i_out)/=0) then
                ! not after wind
                printout= printout.or. &
                abs( (sfr_arr(i_out)-sfr_arr(i_las))/sfr_arr(i_out) ).gt.eps
            endif
        endif
    endif

    if (printout) then
        call print_step(i_out,i_las)
    endif

    end subroutine out_cyc



!***********
    subroutine print_step(i_out,i_las)
    integer(i4b),intent(in)::i_out
    integer(i4b),intent(inout)::i_las
    real::m_tot,m_lost_after_win

    i_las=i_out

    if ((t_arr(i_out)>t_win).and.(f_win/=0)) then
        m_lost_after_win=(mg_arr(i_out,0)-mg_soon_after_win)*(1-f_win)/f_win
    else
        m_lost_after_win=0
    endif

    m_tot=(1-exp(-min(t_arr(i_out),t_win)/tau_inf))*tau_inf*A_inf - &
    mg_t_win - m_lost_after_win

    !output units are solar masses and yrs
    write(17,10) i_out,t_arr(i_out)*to_yea,sfr_arr(i_out)/to_yea, &
    zet_arr(i_out),mg_arr(i_out,0),ms_arr(i_out),m_tot,snr_arr(i_out)/to_yea !float(nok),float(nbad)
    write(*,10) i_out,t_arr(i_out),mg_arr(i_out,0)

    10 format(i4,100g13.6)


    end subroutine print_step




end subroutine che_evo
