program lifetest
use nrtype
use lifetime
use mod_imf
use checod_glob
implicit none

call test_glob
!call che_evo
!call test_imf
!call test_life

contains 

!***********
    subroutine test_imf
    real(sp):: mot,z,result
    integer(i4b):: flag=0,i,n

    result=imf(3.0,'test.imf')

    n=200

    do i=1,n
        mot=m_l+(i-1)*(m_u-m_l)/(n-1)
        result=imf(mot)
        write (*,*) mot,result
    enddo
    end subroutine test_imf

!***********
    subroutine test_life
    real(sp):: mot,z,result
    integer(i4b):: flag=0,i,n

    do while (flag<3)
        write(*,*) "m oppure t, z, flag (0=t,1=m,2=dmdt,3=end)"
        read(*,*) mot,z,flag
        if (flag<3) then
            result=life(mot,z,flag)
            write (*,*) result
        endif
    enddo    

    write(*,*) erre(mot,z,1),erre(mot,z,2)
   end subroutine test_life




end

!**************************************
subroutine test_glob
use nrtype
use nr90_gian, only:qromb_eps
use lifetime
use mod_imf
use checod_glob
use schmidt


implicit none
real(sp)::time,res
integer(i4b)::i
                                                         
call glob_init
k_sch=1
nu_sch=1e-9

i_now=6
t_arr(1:i_now)=(/0.0,2.e7,4.e7,8.e7,16.e7,1e9/)
t_arr(i_now+1)=1.5e9
sfr_arr(1:i_now)=(/10.,20.,100.,50.,10.,5./)
mg_arr(1:i_now,1)=(/20.,40.,200.,100.,20.,10./)
mg_arr(1:i_now,2)=(/0.1,0.2,1.,0.5,0.1,0.05/)
mg_arr=mg_arr*1e9

do i=1,i_now
    call update_mg_and_zet(i)
enddo
write(*,*) 't?'  
read(*,*) time
!write(*,*) sfr(time),zet(time),mg(time,0),mg(time,1),mg(time,2)


res=imf(3.0,'test.imf') ! to initialize t_lif_???


call dmg_fb(time)
call dmg_sf(time)


write(*,*) time
write(*,*) dmg_fb_arr
write(*,*) dmg_sf_arr

call dmg_fb_log(time)
write(*,*) dmg_fb_arr

contains 

!***********

    subroutine dmg_fb(t)
    real(sp),intent(in)::t
    real(sp)::tmin,tmax

    t_fee_bac=t
    tmax=t_fee_bac - t_lif_min
    tmax=max(tmax,0.0)
    tmin=t_fee_bac-t_lif_max
    tmin=max(tmin,0.0)

    do i_fee_bac=1,n_ele
       dmg_fb_arr(i_fee_bac) = -qromb_eps(fun_fee_bac,tmin,tmax,1e-4)
    enddo
    dmg_fb_arr(0)=sum(dmg_fb_arr(1:n_ele))

    end subroutine dmg_fb

!***********
    subroutine dmg_fb_log(t)
    real(sp),intent(in)::t
    real(sp)::tmin,tmax

    t_fee_bac=t
    tmax=t_fee_bac - t_lif_min
    tmax=max(tmax,0.0)
    tmin=t_fee_bac-t_lif_max
    tmin=max(tmin,0.0)

    do i_fee_bac=1,n_ele
       dmg_fb_arr(i_fee_bac) = &
       qromb_eps(fun_fee_bac_log,log(t-tmin),log(t-tmax),1e-4)
    enddo
    dmg_fb_arr(0)=sum(dmg_fb_arr(1:n_ele))

    end subroutine dmg_fb_log


!***********
    subroutine dmg_sf(t)
    real(sp),intent(in)::t

    real(sp)::sf,mgtot
    integer(i4b)::i

    mgtot=mg(t,0)
    sf=sfr_sch(mgtot)
    dmg_sf_arr(0) = - sf
    do i=1,n_ele
       dmg_sf_arr(i) = - sf * mg(t,i) / mgtot
    enddo

    end subroutine dmg_sf


end subroutine test_glob


!**************************************
subroutine che_evo
use nrtype
use nr90_gian, only:qromb_eps
use lifetime
use mod_imf
use checod_glob
use schmidt


implicit none

real(sp)::dt,res
integer(i4b)::i
                                                         
call glob_init
k_sch=1
nu_sch=1e-9

res=imf(3.0,'test.imf') ! to initialize t_lif_???


t_arr(1)=0.0
mg_arr(1,1)=8e10
mg_arr(1,2)=2e10
call update_mg_and_zet(1)

dt=2.5e6

do i_now=1,n_tim-1

    call dmg_fb(t_arr(i_now))
    call dmg_sf(t_arr(i_now))
    call dmg_inf(t_arr(i_now))
    sfr_arr(i_now)=-dmg_sf_arr(0)

    write(*,*) t_arr(i_now),sfr_arr(i_now),zet_arr(i_now), &
    mg_arr(i_now,0)

    t_arr(i_now+1)=t_arr(i_now)+dt
    mg_arr(i_now+1,:)=mg_arr(i_now,:) +  &
     (dmg_sf_arr+dmg_fb_arr+dmg_inf_arr) * dt

    call update_mg_and_zet(i_now+1)

enddo


contains 

!***********

    subroutine dmg_fb(t)
    real(sp),intent(in)::t
    real(sp)::tmin,tmax

    t_fee_bac=t
    tmax=t_fee_bac - t_lif_min
    tmax=max(tmax,0.0)
    tmin=t_fee_bac-t_lif_max
    tmin=max(tmin,0.0)

    do i_fee_bac=1,n_ele
       dmg_fb_arr(i_fee_bac) = -qromb_eps(fun_fee_bac,tmin,tmax,1e-4)
    enddo
    dmg_fb_arr(0)=sum(dmg_fb_arr(1:n_ele))

    end subroutine dmg_fb


!***********
    subroutine dmg_sf(t)
    real(sp),intent(in)::t

    real(sp)::sf,mgtot
    integer(i4b)::i

    mgtot=mg(t,0)
    sf=sfr_sch(mgtot)
    dmg_sf_arr(0) = - sf
    do i=1,n_ele
       dmg_sf_arr(i) = - sf * mg(t,i) / mgtot
    enddo

    end subroutine dmg_sf

!***********
    subroutine dmg_inf(t)
    real(sp),intent(in)::t


    end subroutine dmg_inf


end subroutine che_evo
